Debian Bug report logs - #692295
Uses SIGHUP instead of SIGTERM for graceful shutdown

version graph

Package: couchdb; Maintainer for couchdb is Laszlo Boszormenyi (GCS) <gcs@debian.org>; Source for couchdb is src:couchdb.

Reported by: varacanero <varacanero@zeromail.org>

Date: Sun, 4 Nov 2012 19:06:02 UTC

Severity: serious

Tags: patch, upstream

Found in versions couchdb/1.2.0-2, couchdb/1.2.0-1

Fixed in version couchdb/1.2.0-3

Done: Laszlo Boszormenyi (GCS) <gcs@debian.hu>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, varacanero@zeromail.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 04 Nov 2012 19:06:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to varacanero <varacanero@zeromail.org>:
New Bug report received and forwarded. Copy sent to varacanero@zeromail.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 04 Nov 2012 19:06:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: varacanero <varacanero@zeromail.org>
To: submit@bugs.debian.org
Subject: couchdb: initscript doen't stop/restart service
Date: Sun, 04 Nov 2012 19:55:35 +0100
Package: couchdb
Version: 1.2.0-2
Severity: grave
Justification: renders package unusable

Dear Maintainer,

I think i encountered a regression of "couchdb: Init script doesn't stop
or restart the server"
(http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=681549) in current
couchdb from unstable.
The initscript doen't stop/restart couchdb:

root@debian-wheezy:~# pgrep -u couchdb
3435
3449
3451
3468
3483
root@debian-wheezy:~# /etc/init.d/couchdb stop
[ ok ] Stopping database server: couchdb.
root@debian-wheezy:~# sleep 5
root@debian-wheezy:~# pgrep -u couchdb
3435
3449
3451
3468
3483

I'm using a fresh debian-testing in a vagrant box.

I need to install couchdb from unstable, because i can't install couchdb
from testing in an automated environment due to "couchdb: missing write
permission for /var/run/couchdb"
(http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=681549).

Thanx for caring,

Varac


-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (990, 'testing'), (1, 'unstable')
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-3-amd64 (SMP w/1 CPU core)
Locale: LANG=en_US, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages couchdb depends on:
ii  adduser              3.113+nmu3
ii  erlang-base          1:15.b.1-dfsg-3
ii  erlang-crypto        1:15.b.1-dfsg-3
ii  erlang-eunit         1:15.b.1-dfsg-3
ii  erlang-inets         1:15.b.1-dfsg-3
ii  erlang-os-mon        1:15.b.1-dfsg-3
ii  erlang-ssl           1:15.b.1-dfsg-3
ii  erlang-syntax-tools  1:15.b.1-dfsg-3
ii  erlang-tools         1:15.b.1-dfsg-3
ii  erlang-xmerl         1:15.b.1-dfsg-3
ii  libc6                2.13-35
ii  libcurl3             7.26.0-1
ii  libgcc1              1:4.7.1-7
ii  libicu48             4.8.1.1-9
ii  libjs-jquery         1.7.2+debian-2.1
ii  libjs-jquery-form    6-1
ii  libmozjs185-1.0      1.8.5-1.0.0+dfsg-3.1
ii  libstdc++6           4.7.1-7
ii  lsb-base             4.1+Debian7
ii  procps               1:3.3.3-2

couchdb recommends no packages.

couchdb suggests no packages.

-- Configuration Files:
/etc/couchdb/local.ini changed [not included]
/etc/init.d/couchdb changed [not included]

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Tue, 06 Nov 2012 21:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Frank 'Sigi' Luithle" <frank@luithle.net>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Tue, 06 Nov 2012 21:09:03 GMT) Full text and rfc822 format available.

Message #10 received at 692295@bugs.debian.org (full text, mbox):

From: "Frank 'Sigi' Luithle" <frank@luithle.net>
To: 692295@bugs.debian.org
Subject: I've observed this, too, but cannot reproduce
Date: Tue, 6 Nov 2012 21:54:56 +0100 (CET)
While trying to reproduce this, I was able to observe it once, but then
unable to reproduce further.

The only explanation I can think of right now is some edge case related to
upgrading the package.  I was unable to reproduce that either, however.

In any case, the working version of this package (1.2.0-2) should be
*unfrozen* for wheezy, because shipping 1.2.0-1 with wheezy would mean
shipping a broken package that cannot be installed unattended without
additional measures.



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 25 Nov 2012 09:36:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 25 Nov 2012 09:36:12 GMT) Full text and rfc822 format available.

Message #15 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: control@bugs.debian.org
Cc: 692295@bugs.debian.org
Subject: Not release critical
Date: Sun, 25 Nov 2012 10:34:37 +0100 (CET)
severity 692295 important
kthxbye

Hi,

we are investigating this bug at BSP Essen.

I am downgrading the severity to important as this does not directly 
affect anyone using the package. Upgrade only fails when the service has 
never been restarted manualy before, e.g. when immediately upgrading to 
wheezy after installing squeeze couchdb (or fill in sid where 
appropriate).

-nik



Severity set to 'important' from 'grave' Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Sun, 25 Nov 2012 09:36:14 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 25 Nov 2012 09:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Laszlo Boszormenyi (GCS)" <gcs@debian.hu>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 25 Nov 2012 09:45:05 GMT) Full text and rfc822 format available.

Message #22 received at 692295@bugs.debian.org (full text, mbox):

From: "Laszlo Boszormenyi (GCS)" <gcs@debian.hu>
To: Dominik George <nik@naturalnet.de>, 692295@bugs.debian.org
Subject: Re: Bug#692295: Not release critical
Date: Sun, 25 Nov 2012 09:43:02 +0000
On Sun, 2012-11-25 at 10:34 +0100, Dominik George wrote:
> we are investigating this bug at BSP Essen.
 Please be noted that an upload is pending. Waiting for RM answer, see
#682172 [1].

Regards,
Laszlo/GCS
[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=682172




Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 25 Nov 2012 10:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 25 Nov 2012 10:18:03 GMT) Full text and rfc822 format available.

Message #27 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: "Laszlo Boszormenyi (GCS)" <gcs@debian.hu>
Cc: 692295@bugs.debian.org
Subject: Re: Bug#692295: Not release critical
Date: Sun, 25 Nov 2012 11:16:30 +0100 (CET)
Hi,

>  Please be noted that an upload is pending. Waiting for RM answer, see
> #682172 [1].

this upload does not fix the bug you are replying to.

-nik



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 25 Nov 2012 10:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 25 Nov 2012 10:39:03 GMT) Full text and rfc822 format available.

Message #32 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: 692295@bugs.debian.org
Subject: Regression
Date: Sun, 25 Nov 2012 11:36:23 +0100 (CET)
Hi,

the bug is related to 
https://bugs.launchpad.net/ubuntu/+source/couchdb/+bug/448682/comments/7 :

  couchdb will not be killed by its init script because signal 1 is 
  ignored if the daemon has been started during package installation:

  $ cat /proc/$(cat /var/run/couchdb/couchdb.pid)/status
  [...]
  SigIgn: 0000000000001007
  [...]

  If couchdb has been started by its init script during boot time or from 
  the console then signal 1 is not ignored:

  $ cat /proc/$(cat /var/run/couchdb/couchdb.pid)/status
  SigIgn: 0000000000001006

  The couchdb script uses signal 1 to kill the erlang vm.

What puzzles me is 
https://bugs.launchpad.net/ubuntu/+source/couchdb/+bug/448682/comments/9 :

  Debian fixed this in 1.1.0-2. This version likely will not make it in to 
  Precise as-is; someone needs to go through SRU procedure. I am closing 
  the bugtasks for old versions of Ubuntu and adding ones for new versions

This is bug #601339 in Debian. Why does it appear again in 
couchdb-1.2.0-* ?

-nik



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 25 Nov 2012 11:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 25 Nov 2012 11:03:03 GMT) Full text and rfc822 format available.

Message #37 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: debian-dpkg@lists.debian.org
Cc: 692295@bugs.debian.org
Subject: dpkg sets SIGHUP to SIG_IGN
Date: Sun, 25 Nov 2012 12:00:19 +0100 (CET)
Hi,

at BSP Essen, we are currently investigating Bug #692295 [1].

The problem is that CouchDB, an erlang service, expects SIGHUP to issue a 
clean shutdown. This is what the start/stop script sends to the process.

When the start script is run by dpkg after package installation, it gets 
dpkg's SigIgn mask inherited, and this includes ignoring SIGHUP. Erlang 
itself does not provide a mechanism to control signals (sigh ...).

The question is can we somehow prevent dpkg from setting SIGHUP to SIG_IGN 
for the child process?

Cheers,
Nik

[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=692295



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 25 Nov 2012 11:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 25 Nov 2012 11:45:04 GMT) Full text and rfc822 format available.

Message #42 received at 692295@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Dominik George <nik@naturalnet.de>
Cc: debian-dpkg@lists.debian.org, 692295@bugs.debian.org
Subject: Re: dpkg sets SIGHUP to SIG_IGN
Date: Sun, 25 Nov 2012 12:44:01 +0100
Hi!

On Sun, 2012-11-25 at 12:00:19 +0100, Dominik George wrote:
> at BSP Essen, we are currently investigating Bug #692295 [1].
> 
> The problem is that CouchDB, an erlang service, expects SIGHUP to issue a 
> clean shutdown. This is what the start/stop script sends to the process.
> 
> When the start script is run by dpkg after package installation, it gets 
> dpkg's SigIgn mask inherited, and this includes ignoring SIGHUP. Erlang 
> itself does not provide a mechanism to control signals (sigh ...).

> The question is can we somehow prevent dpkg from setting SIGHUP to SIG_IGN 
> for the child process?

dpkg does not set SIGHUP, that's apt. And this really seems like
should be handled from CouchDB (somehow), if it expects SIGHUP to work
in a certain way, it should make sure to set it up correctly.

Thanks,
Guillem



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Sun, 25 Nov 2012 12:30:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Sun, 25 Nov 2012 12:30:05 GMT) Full text and rfc822 format available.

Message #47 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: control@bugs.debian.org
Cc: 692295@bugs.debian.org
Subject: Bug is in Erlang
Date: Sun, 25 Nov 2012 13:27:14 +0100 (CET)
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

reassign 692295 erlang
retitle 692295 does not properly set up signal handling
severity 692295 important
tags 692295 + upstream
kthxbye

I am reassigning this bug report to the erlang package.

The actual problem is that the Erlang VM does not properly setup signal 
handling upon startup. What happens here is:

- - apt, when started, sets SIGHUP handling to SIG_IGN
- - apt passes this on to dpkg
- - dpkg starts couchdb, which starts beam, always passing on the SigIgn 
  mask

As I understand it, the Erlang program itself has no way of setting up 
signal handling because it can only register callbacks for signals with 
the Erlang VM. The Erlang VM thus should explicitly set its own handlers 
for signals and override the ignore mask it inherits.

- -- 
Cheers,
Nik
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2.0.19 (GNU/Linux)

iQFOBAEBAgA4BQJQsg6HMRpodHRwczovL3d3dy5kb21pbmlrLWdlb3JnZS5kZS9n
cGctcG9saWN5LnR4dC5hc2MACgkQWfyOHW8qgAHEHQf/TDgc5JVOnEgJZvqvftuL
9QBGf9Bpwbab0WRK3h1JIPyAdvwDm29eq4LNecSRiuAJ7IQddwiJ9f/TpvSYja/6
riQ/x3DA7glk1Dk53ozNvp05lVWTReMgT4hwYzWGPYdegqzqoHIZLmUvFHy89dSs
6sC8OTHftgrLRkn54nPjHGnC8F0XQ6Txp0eclzRiixUmumX4RyTqaek8hQkS+ge4
JmvzQcN9LWa81t8An/j1HkWfm0YW0liOtITdSplOcCXumVPKhzA2Ckl+v17zxKPJ
jq9JeDwLJYP93j8bz30K6Iwx5gCN657xq18TfFKJN9Fdczf8MNpQECfRcnO4og1D
3g==
=exe+
-----END PGP SIGNATURE-----



Bug reassigned from package 'couchdb' to 'erlang'. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Sun, 25 Nov 2012 12:30:10 GMT) Full text and rfc822 format available.

No longer marked as found in versions couchdb/1.2.0-2. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Sun, 25 Nov 2012 12:30:10 GMT) Full text and rfc822 format available.

Changed Bug title to 'does not properly set up signal handling' from 'couchdb: initscript doen't stop/restart service' Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Sun, 25 Nov 2012 12:30:11 GMT) Full text and rfc822 format available.

Added tag(s) upstream. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Sun, 25 Nov 2012 12:30:11 GMT) Full text and rfc822 format available.

Added indication that 692295 affects couchdb Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Sun, 25 Nov 2012 12:30:14 GMT) Full text and rfc822 format available.

Marked as found in versions erlang/1:15.b.2-dfsg-2. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Sun, 25 Nov 2012 12:39:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>:
Bug#692295; Package erlang. (Sun, 25 Nov 2012 13:12:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to David Kalnischkies <kalnischkies@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>. (Sun, 25 Nov 2012 13:12:10 GMT) Full text and rfc822 format available.

Message #64 received at 692295@bugs.debian.org (full text, mbox):

From: David Kalnischkies <kalnischkies@gmail.com>
To: Dominik George <nik@naturalnet.de>, debian-dpkg@lists.debian.org, 692295@bugs.debian.org
Subject: Re: dpkg sets SIGHUP to SIG_IGN
Date: Sun, 25 Nov 2012 14:03:02 +0100
JFYI:

On Sun, Nov 25, 2012 at 12:44 PM, Guillem Jover <guillem@debian.org> wrote:
>> The question is can we somehow prevent dpkg from setting SIGHUP to SIG_IGN
>> for the child process?
>
> dpkg does not set SIGHUP, that's apt.

Yeap, and that was actually requested and is expected/needed:
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=463030

A "graceful" kill happens on SIGINT in apt/wheezy in the sense that we will
let dpkg finish whatever it does current (which can be quiet a lot) and stop
after that.


Best regards

David Kalnischkies

P.S.: I don't see why SIGHUP is misused for this by CouchDB …



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>:
Bug#692295; Package erlang. (Sun, 25 Nov 2012 15:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>. (Sun, 25 Nov 2012 15:54:03 GMT) Full text and rfc822 format available.

Message #69 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: deity@lists.debian.org
Cc: 692295@bugs.debian.org
Subject: APT ignoring SIGHUP and passing on to children
Date: Sun, 25 Nov 2012 16:51:55 +0100 (CET)
Hi,

I am currently trying to create a workaround to fix bug #692295 [1].

The problem is that CouchDB uses SIGHUP to trigger a clean shutdown (don't 
ask me why ...) and this signal is ignored by apt. So, when apt runs dpkg 
to install couchdb, and dpkg runs the CouchDB init script, the SigIgn mask 
containing SIGHUP is passed on all the way down to the Erlang VM.

I was first positive that this is an Erlang issue because the VM does not 
reset the ignore mask, but then I tried a work around: I added the 
following line to the start script of couchdb

    trap '' HUP

expecting that this would make the shell reset the handler, but it doesn't 
work, so I suspect that apt uses some other mechanism to ignore the 
signal.

Can any of you give me a hint on how I could possibly get rid of the 
ignore mask on the way to the couchdb daemon?

Cheers,
Nik

[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=692295



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>:
Bug#692295; Package erlang. (Mon, 26 Nov 2012 12:36:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>. (Mon, 26 Nov 2012 12:36:06 GMT) Full text and rfc822 format available.

Message #74 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: 692295@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Workaround in couchdb
Date: Mon, 26 Nov 2012 13:34:02 +0100 (CET)
[Message part 1 (text/plain, inline)]
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

reassign 692295 couchdb 1.2.0-2
found 692295 1.2.0-1
retitle 692295 Uses SIGHUP instead of SIGTERM for graceful shutdown
tags 692295 + patch
tags 692295 + upstream
severity 692295 serious
kthxbye

After a bit of discussion with various parties and thinking a lot about 
the issue, I came to the conclusion that using SIGHUP for graceful 
shutdown is not acceptable. I tested that using SIGTERM also triggers a 
graceful shutdown (well, it has to, because simpler init systems, like on 
many BSD flavours, simply sends SIGTERM to all processes upon shutdown 
...) and patched the wrapper script accordingly.

Attached is a trivial patch that repaces SIGHUP with SIGTERM and it solves 
the problem. This should be reported upstream and discussed with the 
developers.

However, I think the patch should be applied in Debian, probably by 
sponsoring the NMU published at 
http://mentors.debian.net/debian/pool/main/c/couchdb/couchdb_1.2.0-2.1.dsc 
.

Cheers,
Nik
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2.0.19 (GNU/Linux)

iQFOBAEBAgA4BQJQs2F9MRpodHRwczovL3d3dy5kb21pbmlrLWdlb3JnZS5kZS9n
cGctcG9saWN5LnR4dC5hc2MACgkQWfyOHW8qgAGJEQf/R/Eosdwnx1JIuCAjUy6T
HNfRY2DDub0+b2SWUWe/PsrsI5IcLorZcIDk7GdeEO0LvtQ/RQjKcTDKos/teKqn
RPGbq4cIKa6L3aLLbnO8KgWfqLBf4C/vxPmNOWOTocJxTWOcic8AHyJesD34elti
i6iQp6lbKvEistMSTGaxxBcbWQqyEftsghn2tL1Z4O9vqzEuddCGgtfTiDk20XDX
roMqkygWlENk/POP2L7m4QZGGaJGgIVICDEpVArGxUIU+5U15T4A33CDZNduKETL
MsVnhbXAiuNVjWDeT32CivIrNb27MgBFCOMOyhACmfq204yYirfAdIyWdzPigfpC
iQ==
=qv0V
-----END PGP SIGNATURE-----
[couchdb_1.2.0-2.1_sighup.patch (text/x-diff, attachment)]
[couchdb_1.2.0-2.1_sighup.patch.asc (text/plain, attachment)]

Bug reassigned from package 'erlang' to 'couchdb'. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Mon, 26 Nov 2012 12:36:08 GMT) Full text and rfc822 format available.

No longer marked as found in versions erlang/1:15.b.2-dfsg-2. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Mon, 26 Nov 2012 12:36:08 GMT) Full text and rfc822 format available.

Marked as found in versions couchdb/1.2.0-2. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Mon, 26 Nov 2012 12:36:09 GMT) Full text and rfc822 format available.

Marked as found in versions couchdb/1.2.0-1. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Mon, 26 Nov 2012 12:36:09 GMT) Full text and rfc822 format available.

Changed Bug title to 'Uses SIGHUP instead of SIGTERM for graceful shutdown' from 'does not properly set up signal handling' Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Mon, 26 Nov 2012 12:36:10 GMT) Full text and rfc822 format available.

Added tag(s) patch. Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Mon, 26 Nov 2012 12:36:10 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'important' Request was from Dominik George <nik@naturalnet.de> to control@bugs.debian.org. (Mon, 26 Nov 2012 12:36:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Mon, 26 Nov 2012 12:45:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Mon, 26 Nov 2012 12:45:09 GMT) Full text and rfc822 format available.

Message #93 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: submit@bugs.debian.org
Cc: 692295@bugs.debian.org
Subject: RFS: couchdb/1.2.0-2.1 [NMU] [RC]
Date: Mon, 26 Nov 2012 13:41:52 +0100 (CET)
[Message part 1 (text/plain, inline)]
Package: sponsorship-requests
Severity: important

Dear mentors,

I am looking for a sponsor for my package "couchdb". The upload would fix 
RC bug #692295.

* Package name    : couchdb
  Version         : 1.2.0-2.1
* URL             : http://couchdb.apache.org/
* License         : Apache-2.0
  Section         : misc

  It builds those binary packages:

    couchdb    - RESTful document oriented database

To access further information about this package, please visit the 
following URL:

  http://mentors.debian.net/package/couchdb


 Alternatively, one can download the package with dget using this 
command:

    dget -x http://mentors.debian.net/debian/pool/main/c/couchdb/couchdb_1.2.0-2.1.dsc

Changes since the last upload:

couchdb (1.2.0-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Use SIGTERM instead of SIGHUP for graceful shutdown
    (Closes: #692295) [varacanero]

 -- Dominik George <nik@naturalnet.de>  Mon, 26 Nov 2012 12:54:05 +0100

The debdiff is attached.

Regards,
  Dominik George
[couchdb_1.2.0-2.1_sighup.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Mon, 26 Nov 2012 12:45:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Mon, 26 Nov 2012 12:45:11 GMT) Full text and rfc822 format available.

Message #98 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: 692295@bugs.debian.org
Subject: Wrong diff
Date: Mon, 26 Nov 2012 13:42:30 +0100 (CET)
Hi,

the first diff I posted was invalid. See the CCed RFS for the correct 
patch.

-nik



Reply sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
You have taken responsibility. (Mon, 26 Nov 2012 19:03:16 GMT) Full text and rfc822 format available.

Notification sent to varacanero <varacanero@zeromail.org>:
Bug acknowledged by developer. (Mon, 26 Nov 2012 19:03:16 GMT) Full text and rfc822 format available.

Message #103 received at 692295-close@bugs.debian.org (full text, mbox):

From: Laszlo Boszormenyi (GCS) <gcs@debian.hu>
To: 692295-close@bugs.debian.org
Subject: Bug#692295: fixed in couchdb 1.2.0-3
Date: Mon, 26 Nov 2012 19:02:31 +0000
Source: couchdb
Source-Version: 1.2.0-3

We believe that the bug you reported is fixed in the latest version of
couchdb, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 692295@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Laszlo Boszormenyi (GCS) <gcs@debian.hu> (supplier of updated couchdb package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 18 Nov 2012 12:24:24 +0100
Source: couchdb
Binary: couchdb
Architecture: source amd64
Version: 1.2.0-3
Distribution: unstable
Urgency: low
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.hu>
Changed-By: Laszlo Boszormenyi (GCS) <gcs@debian.hu>
Description: 
 couchdb    - RESTful document oriented database
Closes: 652172 692295
Changes: 
 couchdb (1.2.0-3) unstable; urgency=low
 .
   * Rework couchdb own run directory (updates: #681549).
   * Use SIGTERM instead of SIGHUP for graceful shutdown (closes: #692295).
   * Wait until complete stop of service.
   * Use couchdb user for logrotate (closes: #652172).
Checksums-Sha1: 
 9f67fd5adafcc10eb6e4b94eb5a3316b0d94b36d 1243 couchdb_1.2.0-3.dsc
 a2318921c9e9ddaacf52d7d2725e7e06c7042a1c 9844 couchdb_1.2.0-3.debian.tar.gz
 d3031b81b0b235659e555e790343d34b1aff3ada 1026764 couchdb_1.2.0-3_amd64.deb
Checksums-Sha256: 
 c1d56b9c716a49d36e03fa578538cd007b743814b94385f2f95fb19f9a2d1a75 1243 couchdb_1.2.0-3.dsc
 cd003e545fa4457ab2b2ce4fe0d9c1d87339c39f7f207815b9a55ba49642dc72 9844 couchdb_1.2.0-3.debian.tar.gz
 fa203b05e7b13951bd29e0b39058cedac050a3701edded7f0457b1f2db4e33a2 1026764 couchdb_1.2.0-3_amd64.deb
Files: 
 b15dd83199aab018cff2002be2d17889 1243 misc optional couchdb_1.2.0-3.dsc
 3a5c29d90c20ce7a1507bf7e1fd2fc98 9844 misc optional couchdb_1.2.0-3.debian.tar.gz
 c71a05f76dbc545567d89c198807e96f 1026764 misc optional couchdb_1.2.0-3_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAlCzutcACgkQMDatjqUaT90r/gCdFbq3IqfC08sQTG7WGPL1RLqx
M0gAoJAo6Z0m/YbNkzjiirq8CVEhGlgt
=Xs7b
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Tue, 27 Nov 2012 08:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dominik George <nik@naturalnet.de>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Tue, 27 Nov 2012 08:45:03 GMT) Full text and rfc822 format available.

Message #108 received at 692295@bugs.debian.org (full text, mbox):

From: Dominik George <nik@naturalnet.de>
To: "Laszlo Boszormenyi (GCS)" <gcs@debian.hu>
Cc: 692295@bugs.debian.org
Subject: Re: Bug#692295: RFS: couchdb/1.2.0-2.1 [NMU] [RC]
Date: Tue, 27 Nov 2012 09:41:58 +0100 (CET)
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Hi,

> On Mon, 2012-11-26 at 13:41 +0100, Dominik George wrote:
> > I am looking for a sponsor for my package "couchdb". The upload would fix 
> > RC bug #692295.
>  May I ask some things? How is it your package, if you are not listed as
> maintainer nor uploader?

Ask the person who wrote the RFS template generator. On the other hand, 
it's the Debian communities package. Maybe it should say "my version xyz 
of package foo". If you take any offence on this, I really pity you.

> Why do you NMU immediately when I'm known for quick reply?

First, because I can, second, because that's what the DDs at the BSP told 
me to do.

> Why do you ignore other fixes that I've mentioned to you in
> my previous mail? That includes collation with RMs.

You did not mention any fixes. You mentioned a pending upload. I thought 
you were referring to the pending upload of 1.2.0-2 to *wheezy*, which 
does not include any fix for the issue we are discussing.

How about being a bit more specific next time? I also find that you failed 
to post any details of your fix to the BTS. Even though you may be known 
for "quick reply", other parties might be interested in how to fix the 
problem beforehand. You even may want testers for a patch before uploading 
it. In any case, the BTS report log lacks any hint whatsoever about your 
fix.

> Anyway, I've included your patch in -3, even if I'm not convinced about
> it. I think it would have been better to send HUP signal first, then
> after a specified time send TERM signal to couchdb.

Abusing SIGHUP for shutdown in my opinion is a major violation of 
well-estabished standards that should be discussed with upstream.

In conclusion, Debian is a community-effort. I am very convinced that no 
single person owns any part of it, so no single person should ever take 
offence on someone else helping them. If you had e-mailed your own patch 
for the problem to the BTS right when you wrote it, also mentioning that 
you are about to upload it, would have both solve the problem you see 
*and* saved me and the fellows at the BSP quite a few hours of work. 
Please note that you posted your tiny little hint about some pending 
upload only *after* you realized that we were doing work on the issue.

Please also realize that Frank and I spent almost two full days on the 
issue, discussing with dpkg and apt developers and shell gurus all 
possible ways of solving this issue in a way that does *not* violate 
upstream's ideas of signal handling. Although you included the fix in the 
end, and although you claim to be *quick* at it, please try to recognize 
your fellow community members' work and also try to understand if they 
like to get credits for it.

Cheers,
Nik
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2.0.19 (GNU/Linux)

iQFOBAEBAgA4BQJQtHyWMRpodHRwczovL3d3dy5kb21pbmlrLWdlb3JnZS5kZS9n
cGctcG9saWN5LnR4dC5hc2MACgkQWfyOHW8qgAHUjAf+MM3xHsT8l4Nv2lChyOxC
urmpRYX+dZDI9BKOIBRKZHq42e7h8h6EtdPAiQ7x0wuW01hXhVcbnSmP4YR/Jbao
QgaJfXbyJK641MV80tv5qZPN1K13KF3+a4PAwmrIZQpKstC6ekuC5Xm9RsTE3zi5
dzktw6DPxQU4l1v8HDKkECetJmKi2Gf40SZ8bLrW84jHg0hQn9KnEjeV8HstfIvw
PKoKfFz53yRXRYH1dLyIOi1/H5TYzFzOSh2g/+ysd+jU8Gk8efspXvJE7gVP6TA/
+0toWjlPgbK8KiQmKtMAmFtq3BKA6fZybMWkXwkXG4tHDuu3r4yKexgZdBsub4mY
lA==
=e1CH
-----END PGP SIGNATURE-----



Information forwarded to debian-bugs-dist@lists.debian.org, Laszlo Boszormenyi (GCS) <gcs@debian.hu>:
Bug#692295; Package couchdb. (Tue, 27 Nov 2012 21:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Laszlo Boszormenyi (GCS)" <gcs@debian.hu>:
Extra info received and forwarded to list. Copy sent to Laszlo Boszormenyi (GCS) <gcs@debian.hu>. (Tue, 27 Nov 2012 21:51:03 GMT) Full text and rfc822 format available.

Message #113 received at 692295@bugs.debian.org (full text, mbox):

From: "Laszlo Boszormenyi (GCS)" <gcs@debian.hu>
To: Dominik George <nik@naturalnet.de>
Cc: 692295@bugs.debian.org
Subject: Re: Bug#692295: RFS: couchdb/1.2.0-2.1 [NMU] [RC]
Date: Tue, 27 Nov 2012 21:46:55 +0000
Hi Dominik,

On Tue, 2012-11-27 at 09:41 +0100, Dominik George wrote:
> Ask the person who wrote the RFS template generator. On the other hand, 
> it's the Debian communities package. Maybe it should say "my version xyz 
> of package foo". If you take any offence on this, I really pity you.
 I don't take it as an offence, I was just curious why did you write it
as your package.

> > Why do you NMU immediately when I'm known for quick reply?
> First, because I can, second, because that's what the DDs at the BSP told 
> me to do.
 It's always friendly to ask the maintainer first, s/he may have other
things waiting in the queue and/or know a better way to achieve the same
goal.

> > Why do you ignore other fixes that I've mentioned to you in
> > my previous mail? That includes collation with RMs.
> You did not mention any fixes. You mentioned a pending upload. I thought 
> you were referring to the pending upload of 1.2.0-2 to *wheezy*, which 
> does not include any fix for the issue we are discussing.
 I gave you the URL to check and you noted that it doesn't fix the bug
you are referring to. For me, it was look like you checked the attached
diff before answering.
 There's no need to do an extra upload to make an already uploaded
version available in testing (Wheezy this time). A freeze exception is
enough from a release manager.

> How about being a bit more specific next time? I also find that you failed 
> to post any details of your fix to the BTS. Even though you may be known 
> for "quick reply", other parties might be interested in how to fix the 
> problem beforehand. You even may want testers for a patch before uploading 
> it. In any case, the BTS report log lacks any hint whatsoever about your 
> fix.
 ? Please check again #682172 [1], it contains details and attached diff
files. Sure, I'll CC everything next time to the relevant bugreports.

> > Anyway, I've included your patch in -3, even if I'm not convinced about
> > it. I think it would have been better to send HUP signal first, then
> > after a specified time send TERM signal to couchdb.
> 
> Abusing SIGHUP for shutdown in my opinion is a major violation of 
> well-estabished standards that should be discussed with upstream.
 As noted, it's not CouchDB upstream, but the Erlang VM. It does not
ignore SIGHUP itself, but inherit that mask from apt-get . The Erlang VM
actually doesn't have any possibility to change the signal ignorance
mask as I know. Thus even if I note it to upstream, it's a language
barrier and known already.

> In conclusion, Debian is a community-effort. I am very convinced that no 
> single person owns any part of it, so no single person should ever take 
> offence on someone else helping them.
 I agree on this. As a community effort, it needs coordination. You
missed to ask the maintainer first, that you've an RC bugfix, would s/he
upload soon or an NMU would be better after twenty-four hours. Instead,
you immediately ignored the maintainer and asked everyone for NMU
sponsorship. I asked questions to learn what I can do better next time
to prevent misunderstanding. It was you who make offence and even CC to
a closed bugreport.

>  If you had e-mailed your own patch 
> for the problem to the BTS right when you wrote it, also mentioning that 
> you are about to upload it, would have both solve the problem you see 
> *and* saved me and the fellows at the BSP quite a few hours of work.
 A discussion was going on an other bugreport and you were given with an
URL of that. You are right that only when I've learnt you are working on
that issue. I had the presupposition that you'll check it and when you
replied that doesn't fix the issue, I thought you did.

> Please note that you posted your tiny little hint about some pending 
> upload only *after* you realized that we were doing work on the issue.
 I agree on this, I should have tag the bug as pending. The little hint
about upload pending contained the URL with the attached diff and the
information release managers are involved in discussion.

> Please also realize that Frank and I spent almost two full days on the 
> issue, discussing with dpkg and apt developers and shell gurus all 
> possible ways of solving this issue in a way that does *not* violate 
> upstream's ideas of signal handling. Although you included the fix in the 
> end, and although you claim to be *quick* at it, please try to recognize 
> your fellow community members' work and also try to understand if they 
> like to get credits for it.
 I do note others work in changelogs, see some quick examples[2][3][4].
About the SIGHUP change, you mentioned '[varacanero]', that I couldn't
parse. On the other hand, you are noted in couchdb_sighup.patch as it
was your work and I do honor it.

Regards,
Laszlo/GCS
[1] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=682172
[2] http://packages.qa.debian.org/s/sqlite3/news/20120516T212014Z.html
[3] http://packages.qa.debian.org/p/python-eventlet/news/20121117T144838Z.html
[4] http://packages.qa.debian.org/w/whatweb/news/20120605T213524Z.html




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 04 Jan 2013 07:28:18 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 14:02:38 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.